using UnityEditor;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;

class PathHelper : MonoBehaviour {
	
	
	[MenuItem ("2D/Toggle Looping _l")]
	static void ToggleLoop () 
	{
		if (Selection.activeTransform==null)
		{
			Debug.Log("ERRORA");
			return;
		}
		LineGenerator lg = Selection.activeTransform.GetComponent<LineGenerator>();
		
		if (lg!=null)
		{
			lg.loop=!lg.loop;
			return;
		}
		
		if (Selection.activeTransform.parent==null)
		{
			Debug.Log("ERRORB");
			return;
		}
		
		lg = Selection.activeTransform.parent.GetComponent<LineGenerator>();
		
		if (lg!=null)
		{
			lg.loop=!lg.loop;
			return;
		}
		else
		{			
			Debug.Log("ERRORC");
			return;		
		}
		
	}
	
	[MenuItem ("2D/New Vertex to right _d")]
	static void NewToRight () 
	{
		if (Selection.activeTransform==null)
		{
			Debug.Log("ERRORA");
			return;
		}
		
		
		Transform target = Selection.activeTransform;
		
		LevelVertex levelvertex = target.GetComponent<LevelVertex>();
		//check is vertex type
		if (levelvertex==null)
		{
			Debug.Log("ERRORB");
			return;
		}
		
		
		//check that parent is a LineGenerator
		Transform parent = target.parent;
		
		LineGenerator lineGenerator = parent.GetComponent<LineGenerator>();
		if (lineGenerator==null)
		{
			Debug.Log("ERRORC");
			return;
		}
		
		
		//tidy up
		lineGenerator.ClearFree();	
	
		//collect list of vertices in a mutable array
		List<LevelVertex> vertexlist = new List<LevelVertex>();
				
		for (int i=0;i<lineGenerator.vertices.Length;i++)
		{
			vertexlist.Add(lineGenerator.vertices[i]);
		}
		
		int itemindex = vertexlist.IndexOf(levelvertex);
		
		if (itemindex==-1)
		{
			Debug.Log("ERRORD");
			return;
		}
				
		
		GameObject newVertex = Instantiate(target.gameObject,target.position,Quaternion.identity) as GameObject;
		newVertex.name=levelvertex.name;
		newVertex.transform.parent=target.parent;
		
		Selection.activeTransform=newVertex.transform;
		
		vertexlist.Insert(itemindex,newVertex.GetComponent<LevelVertex>());
		
		lineGenerator.vertices = vertexlist.ToArray();
		
	}
	
	
	
	
	
	
	[MenuItem ("2D/New Vertex to left _a")]
	static void NewToLeft () 
	{
		if (Selection.activeTransform==null)
		{
			Debug.Log("ERRORA");
			return;
		}
		
		
		Transform target = Selection.activeTransform;
		
		LevelVertex levelvertex = target.GetComponent<LevelVertex>();
		//check is vertex type
		if (levelvertex==null)
		{
			Debug.Log("ERRORB");
			return;
		}
		
		
		//check that parent is a LineGenerator
		Transform parent = target.parent;
		
		LineGenerator lineGenerator = parent.GetComponent<LineGenerator>();
		if (lineGenerator==null)
		{
			Debug.Log("ERRORC");
			return;
		}
		
		
		//tidy up
		lineGenerator.ClearFree();	
	
		//collect list of vertices in a mutable array
		List<LevelVertex> vertexlist = new List<LevelVertex>();
				
		for (int i=0;i<lineGenerator.vertices.Length;i++)
		{
			vertexlist.Add(lineGenerator.vertices[i]);
		}
		
		int itemindex = vertexlist.IndexOf(levelvertex);
		
		if (itemindex==-1)
		{
			Debug.Log("ERRORD");
			return;
		}
				
		
		GameObject newVertex = Instantiate(target.gameObject,target.position,Quaternion.identity) as GameObject;
		newVertex.name=levelvertex.name;
		newVertex.transform.parent=target.parent;
		
		Selection.activeTransform=newVertex.transform;
		
		vertexlist.Insert(itemindex+1,newVertex.GetComponent<LevelVertex>());
		
		lineGenerator.vertices = vertexlist.ToArray();
		
	}
}